<?php
header("content-type: text/html; charset=utf-8");
// admin : galatool = default Zugang
session_start();
include "config/config.php";
require "secret/displayfunctions.inc.php";
$dsp = new DisplayFunctions();

chdir('config');
include "attributes.php";
chdir('../');
chdir('secret');
include "session_handler.inc.php";
chdir('../');

	@include "languages/korean_workaround.inc.php";
	@include "languages/taiwan_workaround.inc.php";
	@include "languages/japanese_workaround.inc.php";
	@include "languages/chinese_workaround.inc.php";

if (isset($_GET['logout'])) {
	// unset session at session handler
	log_out();

	unset($_SESSION['s_systems']);
	unset($_SESSION['s_lastweek']);
	unset($_SESSION['s_too_old']);
	unset($_SESSION['s_req_user']);
	unset($_SESSION['s_notices']);
	unset($_SESSION['s_players']);
	unset($_SESSION['s_allies']);
	unset($_SESSION['s_reports']);
	unset($_SESSION['s_umods']);
	unset($_SESSION['s_moons']);
	unset($_SESSION['s_raidable']);
	unset($_SESSION['s_empty_systems']);
	unset($_SESSION['s_full_systems']);
	unset($_SESSION['s_minimumresources']);
	unset($_SESSION['s_spioarray']);
	if (isset($_SESSION['s_saves'])) {
		unset($_SESSION['s_saves']);
	}

	unset($_SESSION['s_username']);
	unset($_SESSION['s_userid']);
	//unset($_SESSION['lang']); // not needed - redefined anyway
	unset($_SESSION['s_ogame_playerid']);
	unset($_SESSION['s_loggedin']);
	unset($_SESSION['s_stylepath']);
	unset($_SESSION['s_timezone_offset']);
	unset($_SESSION['s_ogame_offset']);

	unset($_SESSION['s_isadmin']);
	unset($_SESSION['s_serverurl']);
	unset($_SESSION['s_cansearch']);
	unset($_SESSION['s_caninsert']);
	unset($_SESSION['s_candelete']);
	unset($_SESSION['s_statusview']);
	unset($_SESSION['s_probeview']);
	unset($_SESSION['s_userman']);
	unset($_SESSION['s_allyhistory']);
	unset($_SESSION['s_diplomatic']);
	unset($_SESSION['s_fleetinfo']);
	unset($_SESSION['s_activities']);
	unset($_SESSION['s_maintenance']);

	unset($_SESSION['s_hits']);
	unset($_SESSION['s_statspage']);

	unset($_SESSION['s_bb_coordinates']);
	unset($_SESSION['s_bb_moon']);
	unset($_SESSION['s_bb_debris']);
	unset($_SESSION['s_bb_ally']);
	unset($_SESSION['s_bb_allydetails']);
	unset($_SESSION['s_bb_playername']);
	unset($_SESSION['s_bb_banned']);
	unset($_SESSION['s_bb_vacation']);
	unset($_SESSION['s_bb_noob']);
	unset($_SESSION['s_bb_inactive']);
	unset($_SESSION['s_bb_longinactive']);
	unset($_SESSION['s_additional_links']);
	unset($_SESSION['s_global_links']);

	unset($_SESSION['s_waffentech']);
	unset($_SESSION['s_schildtech']);
	unset($_SESSION['s_rpz']);
	unset($_SESSION['s_vbt']);
	unset($_SESSION['s_hra']);
	unset($_SESSION['s_impulse']);

}

if (isset($_GET['language'])) {
	unset($_SESSION['lang']);
	switch ($_GET['language']) {
		case "german"    : $_SESSION['lang']="german"; break;
		case "english"   : $_SESSION['lang']="english"; break;
		case "spanish"   : $_SESSION['lang']="spanish"; break;
		case "dutch"     : $_SESSION['lang']="dutch"; break;
		case "balkan"    : $_SESSION['lang']="balkan"; break;
		case "french"    : $_SESSION['lang']="french"; break;
		case "portugues" : $_SESSION['lang']="portugues"; break;
		case "polish"    : $_SESSION['lang']="polish"; break;
		case "italian"   : $_SESSION['lang']="italian"; break;
		case "turkish"   : $_SESSION['lang']="turkish"; break;
		case "danish"    : $_SESSION['lang']="danish"; break;
		case "brazilian" : $_SESSION['lang']="brazilian"; break;
		case "russian"   : $_SESSION['lang']="russian"; break;
		case "swedish"   : $_SESSION['lang']="swedish"; break;
		case "greek"     : $_SESSION['lang']="greek"; break;
		case "romanian"  : $_SESSION['lang']="romanian"; break;
		case "hungarian" : $_SESSION['lang']="hungarian"; break;
		case "czech"     : $_SESSION['lang']="czech"; break;
		case "korean"    : $_SESSION['lang']="korean"; break;
		case "norwegian" : $_SESSION['lang']="norwegian"; break;
		case "taiwan"    : $_SESSION['lang']="taiwan"; break;
		case "japan"     : $_SESSION['lang']="japan"; break;
		case "chinese"   : $_SESSION['lang']="chinese"; break;
		case "bulgarian" : $_SESSION['lang']="bulgarian"; break;
		case "lithuanian" : $_SESSION['lang']="lithuanian"; break;
		case "latvian"   : $_SESSION['lang']="latvian"; break;
		case "finnish"   : $_SESSION['lang']="finnish"; break;
		case "slovak"    : $_SESSION['lang']="slovak"; break;
		case "croatian"    : $_SESSION['lang']="croatian"; break;
		case "serbian"    : $_SESSION['lang']="serbian"; break;
		case "slovenian"    : $_SESSION['lang']="slovenian"; break;
		default          : $_SESSION['lang']="german"; break;
	}
}

if (!isset($_SESSION['lang'])) {
	$_SESSION['lang'] = $default_language;
}

switch ($_SESSION['lang']) {
	case "german"    : include "languages/german.inc.php"; break;
	case "english"   : include "languages/english.inc.php"; break;
	case "spanish"   : include "languages/spanish.inc.php"; break;
	case "dutch"     : include "languages/dutch.inc.php"; break;
	case "balkan"    : include "languages/balkan.inc.php"; break;
	case "french"    : include "languages/french.inc.php"; break;
	case "portugues" : include "languages/portugues.inc.php"; break;
	case "polish"    : include "languages/polish.inc.php"; break;
	case "italian"   : include "languages/italian.inc.php"; break;
	case "turkish"   : include "languages/turkish.inc.php"; break;
	case "danish"    : include "languages/danish.inc.php"; break;
	case "brazilian" : include "languages/brazilian.inc.php"; break;
	case "russian"   : include "languages/russian.inc.php"; break;
	case "swedish"   : include "languages/swedish.inc.php"; break;
	case "greek"     : include "languages/greek.inc.php"; break;
	case "romanian"  : include "languages/romanian.inc.php"; break;
	case "hungarian" : include "languages/hungarian.inc.php"; break;
	case "czech"     : include "languages/czech.inc.php"; break;
	case "korean"    : include "languages/korean.inc.php"; break;
	case "norwegian" : include "languages/norwegian.inc.php"; break;
	case "taiwan"    : include "languages/taiwan.inc.php"; break;
	case "japan"     : include "languages/japanese.inc.php"; break;
	case "chinese"  : include "languages/chinese.inc.php"; break;
	case "bulgarian"  : include "languages/bulgarian.inc.php"; break;
	case "lithuanian" : include "languages/lithuanian.inc.php"; break;
	case "latvian"   : include "languages/latvian.inc.php"; break;
	case "finnish"   : include "languages/finnish.inc.php"; break;
	case "slovak"    : include "languages/slovak.inc.php"; break;
	case "croatian"  : include "languages/croatian.inc.php"; break;
	case "serbian"  : include "languages/serbian.inc.php"; break;
	case "slovenian"  : include "languages/slovenian.inc.php"; break;
	default          : include "languages/german.inc.php"; break;
}

$path = $_SERVER['PHP_SELF'];
$pos = strrpos($path,"/");
$path = substr($path,0,$pos+1);

if (isset($_POST['username']) && isset($_POST['pass']) || isset($_GET['username']) && isset($_GET['pass'])) {
	$loginfailure = true;
	mysql_connect($dbhost,$dbusername,$dbpassword) or die(mysql_error());
	mysql_select_db($dbname) or die(mysql_error());
	if (isset($_POST['username']) && isset($_POST['pass'])) {
		$username     = trim(stripslashes($_POST['username']));
		$old_userpass = preg_replace("/[^a-zA-Z0-9äÄöÖüÜß_\s\-\.]/","",$_POST['pass']);
		$userpass     = trim(stripslashes($_POST['pass']));
	} else {
		$username     = trim(stripslashes($_GET['username']));
		$old_userpass = preg_replace("/[^a-zA-Z0-9äÄöÖüÜß_\s\-\.]/","",$_GET['pass']);
		$userpass     = trim(stripslashes($_GET['pass']));
	}

	$query = "SELECT u.*,p.waffentech, p.schildtech,p.rpz,p.vbt,p.hra,p.impulse FROM $utablename u
		      LEFT JOIN $playertable p ON (u.ingame = p.playername)
	          WHERE username='".mysql_real_escape_string($username)."' AND userpass='".md5($userpass)."' AND new_password='true' AND status='active'";
	$res = mysql_query($query) or die(mysql_error());

	if (mysql_num_rows($res) == 0) {
		// try once again with the old password approach
		$query = "SELECT u.*,p.waffentech, p.schildtech,p.rpz,p.vbt,p.hra,p.impulse FROM $utablename u
			      LEFT JOIN $playertable p ON (u.ingame = p.playername)
		          WHERE username='".mysql_real_escape_string($username)."' AND userpass='".md5($old_userpass)."' AND new_password='false' AND status='active'";
		$res = mysql_query($query) or die(mysql_error());
		$line = mysql_fetch_object($res);

		if (mysql_num_rows($res) > 0) {
			// set new password hash
			$update_query = "UPDATE $utablename SET userpass='".md5($userpass)."', new_password='true' WHERE id=".$line->id;
			mysql_query($update_query) or die(mysql_error());
		}
	}

	if (mysql_num_rows($res) > 0) {
		if (!isset($line)) $line = mysql_fetch_object($res);

		IF (isset($_SESSION['s_serverurl']) && ($_SESSION['s_serverurl'] != $_SERVER['HTTP_HOST'].$path) ) {
			echo "running backup...<br>";
			backup_session();
		}
		// don't forget session_handler.inc.php!

		$_SESSION['s_username']        = $line->username;
		$_SESSION['s_userid']          = $line->id;
		$_SESSION['s_ogame_playerid']  = $line->ogame_playerid;
		$_SESSION['s_loggedin']        = true;
		$_SESSION['s_stylepath']       = $line->stylepath;
		$_SESSION['s_timezone_offset'] = $line->timezone_offset;
		$_SESSION['s_ogame_offset']    = $line->ogame_offset;
		if (isset($line->session_save)) {
			$_SESSION['s_saves']       = unserialize($line->session_save);
		} else {
			$update_query = "ALTER TABLE $utablename ADD session_save TEXT NOT NULL";
			mysql_query($update_query);
			$_SESSION['s_saves']       = "";
		}


		// websim data
		$_SESSION['s_waffentech'] = (empty($line->waffentech)) ? 0 : $line->waffentech;
		$_SESSION['s_schildtech'] = (empty($line->schildtech)) ? 0 : $line->schildtech;
		$_SESSION['s_rpz']        = (empty($line->rpz)) ? 0 : $line->rpz;
		$_SESSION['s_vbt']        = (empty($line->vbt)) ? 0 : $line->vbt;
		$_SESSION['s_hra']        = (empty($line->hra)) ? 0 : $line->hra;
		$_SESSION['s_impulse']    = (empty($line->impulse)) ? 0 : $line->impulse;

		$_SESSION['s_serverurl']   = $_SERVER['HTTP_HOST'].$path;
		$_SESSION['s_isadmin']     = ($line->is_admin =="true") ? true : false;
		$_SESSION['s_cansearch']   = ($line->cansearch =="true") ? true : false;
		$_SESSION['s_caninsert']   = ($line->caninsert =="true") ? true : false;
		$_SESSION['s_candelete']   = ($line->candelete =="true") ? true : false;
		$_SESSION['s_statusview']  = ($line->statusview =="true") ? true : false;
		$_SESSION['s_probeview']   = ($line->probeview =="true") ? true : false;
		$_SESSION['s_userman']     = ($line->userman =="true") ? true : false;
		$_SESSION['s_allyhistory'] = ($line->allyhistory =="true") ? true : false;
		$_SESSION['s_diplomatic']  = ($line->diplomatic =="true") ? true : false;
		$_SESSION['s_fleetinfo']   = ($line->fleetinfo =="true") ? true : false;
		$_SESSION['s_activities']  = ($line->activities =="true") ? true : false;
		$_SESSION['s_maintenance']  = ($line->maintenance =="true") ? true : false;

		$_SESSION['s_hits']		  = 20;
		$_SESSION['s_statspage']  = $line->statspage;
		$loginfailure = false;


		// personal links
		$addinonal_links_lines = explode("\n",$line->links);
		$_SESSION['s_additional_links'] = array();
		foreach ($addinonal_links_lines as $link_line) {
			$line_parts = explode(";",$link_line);
			if (count($line_parts) == 2) {
				if (trim($line_parts[1]) == "") {
					array_push($_SESSION['s_additional_links'],array(trim($line_parts[0])));
				} else {
					if (substr($line_parts[1],0,7) != "http://" && substr($line_parts[1],0,8) != "https://") {
						$line_parts[1] = "http://".$line_parts[1];
					}
					array_push($_SESSION['s_additional_links'],array(trim($line_parts[0]),trim($line_parts[1])));
				}
			}
		}

		if (count($_SESSION['s_additional_links']) == 0) {
			array_push($_SESSION['s_additional_links'],array("Ogame","http://www.ogame.de"));
		}
		unset($addinonal_links_lines);
		unset($line_parts);
		unset($link_line);

		// colors
		$_SESSION['s_bb_coordinates']  = $line->bb_coordinates;
		$_SESSION['s_bb_moon']         = $line->bb_moon;
		$_SESSION['s_bb_debris']       = $line->bb_debris;
		$_SESSION['s_bb_ally']         = $line->bb_ally;
		$_SESSION['s_bb_allydetails']  = $line->bb_allydetails;
		$_SESSION['s_bb_playername']   = $line->bb_playername;
		$_SESSION['s_bb_banned']       = $line->bb_banned;
		$_SESSION['s_bb_vacation']     = $line->bb_vacation;
		$_SESSION['s_bb_noob']         = $line->bb_noob;
		$_SESSION['s_bb_inactive']     = $line->bb_inactive;
		$_SESSION['s_bb_longinactive'] = $line->bb_longinactive;


		// global links - from admin account
		if ($_SESSION['s_isadmin'] != true) {
			$query = "SELECT * FROM $utablename WHERE is_admin='true'";
			$res = mysql_query($query) or die(mysql_error());
			if (mysql_num_rows($res) > 0) {
				$line = mysql_fetch_object($res);
				$global_links_lines = explode("\n",$line->links);
				$_SESSION['s_global_links'] = array();
				foreach ($global_links_lines as $link_line) {
					$line_parts = explode(";",$link_line);
					if (count($line_parts) == 2) {
						if (trim($line_parts[1]) == "") {
							array_push($_SESSION['s_global_links'],array(trim($line_parts[0])));
						} else {
							if (substr($line_parts[1],0,7) != "http://" && substr($line_parts[1],0,8) != "https://") {
								$line_parts[1] = "http://".$line_parts[1];
							}
							array_push($_SESSION['s_global_links'],array(trim($line_parts[0]),trim($line_parts[1])));
						}

					}
				}
			} // else - no amin account any more
		}
	}
	if (!$loginfailure) {
		$query = "UPDATE $utablename SET logins=logins+1, lastlogin=NOW() WHERE id='".$_SESSION['s_userid']."'";
		$res = mysql_query($query) or die(mysql_error());
		$query = "INSERT INTO $iptablename (userid,ip,logintime) VALUES ('".$_SESSION['s_userid']."','".$_SERVER['REMOTE_ADDR']."',NOW())";
		$res = mysql_query($query) or die(mysql_error());
		$query = "SELECT id FROM $iptablename WHERE userid='".$_SESSION['s_userid']."' ORDER BY logintime ASC";
		$res = mysql_query($query) or die(mysql_error());
		if (mysql_num_rows($res) > 50) {
			$number = mysql_num_rows($res);
			$where = " id IN (";
			$i = 0;
			while ($line = mysql_fetch_object($res)) {
				if ($i < ($number-50)) $where .= $line->id.",";
				else break;
				$i++;
			}
			$where = substr($where,0,strlen($where)-1).")";
			$query = "DELETE FROM $iptablename WHERE ".$where;
			$res = mysql_query($query) or die(mysql_error());
		}
	}
}


if (!isset($_SESSION['s_loggedin']) || $_SESSION['s_loggedin'] && $_SESSION['s_serverurl'] != $_SERVER['HTTP_HOST'].$path) { // Loginseite
?>
<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title><?php echo PROGRAM_NAME." ".VERSION; ?></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<link rel="stylesheet" type="text/css" href="dojo/dijit/themes/claro/claro.css">
<link rel="stylesheet" type="text/css" href="secret/styles.css">
</head>
<body class="claro">
<form action="index.php" method="POST" accept-charset="utf-8">
<table class="startsHidden standard" cellpadding="0" cellspacing="0" border="0" style="margin-top:200px; width:250px;" align="center">
<tr class="firstcolor"><td colspan="2" align="center" class="tblhead"><?php echo PROGRAM_NAME." ".VERSION; ?> - Login</td></tr>
<?php
if (isset($loginfailure) && $loginfailure) echo "<tr class=\"firstcolor\"><td colspan=\"2\" class=\"failure\">".L_LOGINFAILURE."</td></tr>\n";
if (isset($_GET['timeout'])) echo "<tr class=\"firstcolor\"><td colspan=\"2\" class=\"failure\">".L_TIMEOUT."</td></tr>\n";

?>
<tr class="firstcolor"><td colspan="2" align="center"><?php echo $owner; ?></td></tr>
<tr class="firstcolor"><td colspan="2" align="center">&nbsp;</td></tr>
<tr class="firstcolor"><td style="padding-top:5px; padding-left:5px;"><?php echo L_USERNAME; ?>:</td><td style="padding-top:5px;"><?php echo $dsp->input_field("username","","width:150px;","text",true,20,40)  ?></td></tr>
<tr class="firstcolor"><td style="padding-top:5px; padding-left:5px;"><?php echo L_PASSWORD; ?>:</td><td style="padding-top:5px;"><?php echo $dsp->input_field("pass","","width:150px;","password",true,20,40)  ?></td></tr>
<tr class="firstcolor"><td colspan="2" align="center" style="padding-top:5px;"><input class="button" type="submit" name="OK" value="OK" /></td></tr>
<tr class="firstcolor"><td colspan="2" align="center"><br><?php echo L_LANGUAGE; ?>
</td></tr>
<tr class="firstcolor">
<td colspan="2" align="center">
<div name="select" dojoType="dijit.form.Select" style="width:130px;" maxheight="400" id="language" jsId="language" onChange="document.location.href='index.php?language='+dijit.byId('language').attr('value');">
<?php
$languages = array(
array("german","ger-icon.gif","Deutsch"),
array("english","en-icon.gif","English"),
array("spanish","es-icon.gif","Español"),
array("dutch","dutch-icon.gif","Nederlands"),
array("balkan","balkan-icon.gif","Balkan"),
array("french","french-icon.gif","Français"),
array("portugues","pt-icon.gif","Português"),
array("polish","pl-icon.gif","Polski"),
array("italian","it-icon.gif","Italiano"),
array("turkish","tk-icon.gif","Türkçe"),
array("danish","dk-icon.gif","Dansk"),
array("brazilian","br-icon.gif","Brazilian"),
array("russian","ru-icon.gif","Русский"),
array("swedish","sw-icon.gif","Svenska"),
array("greek","gr-icon.gif","Ελληνικά"),
array("romanian","ro-icon.gif","Română"),
array("hungarian","hu-icon.gif","Magyar"),
array("czech","cz-icon.gif","Čeština"),
array("korean","kr-icon.gif",$korean),
array("norwegian","no-icon.gif","Norsk bokmål"),
array("taiwan","tw-icon.gif",$taiwan),
array("japan","jp-icon.gif",$japan),
array("chinese","cn-icon.gif",$chinese),
array("bulgarian","bg-icon.gif","Български"),
array("lithuanian","lt-icon.gif","lietuvių kalba"),
array("latvian","lv-icon.gif","Latvian"),
array("finnish","fi-icon.gif","Suomi"),
array("slovak","sk-icon.gif","Slovenčina"),
array("croatian","hr-icon.gif","Croatian"),
array("serbian","se-icon.gif","Serbian"),
array("slovenian","si-icon.gif","Slovenian")
);
foreach ($languages as $language) {
	if($_SESSION['lang']==$language[0]) $selected = 'selected="selected"';
	else $selected = '';
	echo '<span value="'.$language[0].'" '.$selected.'><img src="images/'.$language[1].'" alt="'.$language[2].'" border="0">&nbsp;'.$language[2].'</span>';
}
echo '
</div>
</td>
</tr>

<tr class="firstcolor"><td colspan="2">&nbsp;</td></tr>
<tr class="firstcolor"><td colspan="2" align="center">
<input class="button" type="button" value="'.L_REGISTER.'" onclick="window.location.href=\'register.php\'" />&nbsp;
<input class="button" type="button" value="'.L_PWLOST.'" onclick="window.location.href=\'lost_password.php\'" /></td>
</tr>
</table>';

if (isset($_GET['redirect'])) {
	echo "<input type=\"hidden\" name=\"redirect\" value=\"".$_GET['redirect']."\">\n";
}
?>
</form>
<script type="text/javascript"	src="https://ajax.googleapis.com/ajax/libs/dojo/1.5/dojo/dojo.xd.js" djConfig="parseOnLoad: true"></script>
<script type="text/javascript">
dojo.require("dijit.form.Button");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.Select");

dojo.addOnLoad(function(){
	dojo.query(".startsHidden")
		.style("opacity", 100)
		.removeClass("startsHidden")
	;
})
</script>
</body>
</html>
<?php
} else {
	if (isset($userpass) && $userpass == "galatool") {
		$page_forward = "secret/change_password.php";
	} elseif(isset($_POST['redirect'])) {
		$redirect = $_POST['redirect'];
		$current_page = $_SERVER['REQUEST_URI'];
		$current_page = str_replace("index.php","",$current_page);
		if (substr($redirect,0,strlen($current_page)) == $current_page) {
			$page_forward = urldecode($redirect);
		} else {
			$page_forward = "secret/index.php";
		}
	} else {
		$page_forward = "secret/index.php";
	}
?>
  <HTML>
	<HEAD>
		<TITLE>DONE</TITLE>
		<meta http-equiv="content-type" content="text/html; charset=UTF-8">
		<meta http-equiv="refresh" content="0; URL=<?php echo $page_forward; ?>">
		<link rel=stylesheet type="text/css" href="secret/styles.css">
	</HEAD>
	<BODY>
		<table cellpadding="0" cellspacing="0" border="0" style="width:250px;" align="center" height="100%">
		<tr><td valign="middle">
		<a class="menulink" href="<?php echo $page_forward; ?>"><?php echo INDEX_PAGEFORWARD; ?></a>
		</td>
		</tr>
		</table>
	</BODY>
  </HTML>
<?php
}

?>