<?php
header("content-type: text/html; charset=utf-8");
session_start();

chdir("../");
include "logincheck.inc.php";
if (!$_SESSION['s_activities']) {
	$error_page_code = "permission";
	include "errorpage.php";
	exit();
}
include "languages.php";
require "../config/config.php";
include "../config/attributes.php";

if (!isset($_POST['playerid'])) {
	if (!isset($_GET['playerid'])) {
		exit("PlayerID missing");
	} else {
		$playerid = intval($_GET['playerid']);
	}
} else {
	$playerid = intval($_POST['playerid']);
}

if (isset($_POST['set_active'])) {
	if (!$_SESSION['s_caninsert']) {
		$error_page_code = "permission";
		include "errorpage.php";
		exit("");
	}
	require "parser_activities.inc.php";
	$activity_parser = new ActivityParser($global_mysql_con,$player_activity,$utablename,$global_universe);

	// we need to convert local time to "Ogame Time" which is GMT+1
	$time = time();
	// convert into GMT first
	$offset = date("O",$time);
	$sign    = substr($offset,0,1);
	$hours   = substr($offset,1,2);
	$minutes = substr($offset,-2);
	if ($sign == "+") {
		$time -= $hours * 60 * 60;
		$time -= $minutes * 60;
	} else {
		$time += $hours * 60 * 60;
		$time += $minutes * 60;
	}
	// now into Ogame Time
	$time += (1 + date("I",$time) ) * 60 * 60; // +1 or +2 depending on daylight saving times

	$dow = date("w",$time);

	$result = $activity_parser->collect_manual_activity($playerid,date("Y",$time),date("m",$time),date("d",$time),date("H",$time),date("i",$time),$dow);
	if ($result === false) {
		exit("Unexpected error occurred for manualy activity");
	}
	$result = $activity_parser->insert_into_database();

	if ($result === true) {
		exit("true"); // we are done
	} else {
		$errors = $activity_parser->get_error_object()->get_plain_message_text();
		exit($errors);
	}
} elseif (isset($_POST['date']) && isset($_POST['time_h']) && isset($_POST['time_m'])) {
	if (!$_SESSION['s_caninsert']) {
		$error_page_code = "permission";
		include "errorpage.php";
		exit("");
	}
	$date = $_POST['date'];
	$time_h = $_POST['time_h'];
	$time_m = $_POST['time_m'];
	if (preg_replace("/\d{4}\-\d{2}\-\d{2}/", "", $date) != "") exit("false");
	if (preg_replace("/\d{2}/", "", $time_h) != "") exit("false");
	if (preg_replace("/\d{2}/", "", $time_m) != "") exit("false");

	try {
	    $date_obj = new DateTime($date);
	} catch (Exception $e) {
	    exit($e->getMessage());
	}
	$dow = $date_obj->format('w');

	$date = explode("-", $date);

	require "parser_activities.inc.php";
	$activity_parser = new ActivityParser($global_mysql_con,$player_activity,$utablename,$global_universe);
	$result = $activity_parser->collect_manual_activity($playerid,$date[0],$date[1],$date[2],$time_h,$time_m,$dow);
	if ($result === false) {
		exit("Unexpected error occurred for manualy activity");
	}
	$result = $activity_parser->insert_into_database();
	if ($result === true) {
		exit("true"); // we are done
	} else {
		$errors = $activity_parser->get_error_object()->get_plain_message_text();
		exit($errors);
	}
}

if (!isset($_GET['playername'])) {
	exit("Player name missing");
} else {
	$playername = $_GET['playername'];
}


?>
<div class="startsHidden">
<select name="select" dojoType="dijit.form.Select" id="view" jsId="view" onChange="selection_changed('<?php echo $playerid; ?>')">
<option value="day"><?php echo DETAILEDINFO_DAY_VIEW; ?></option>
<option value="week"><?php echo DETAILEDINFO_WEEK_VIEW;?></option>
</select>
<div id="calendar_from" jsId="calendar_from" class="claro" style="font-size: 8pt; display:none; position:absolute; top:50px; left:10px; z-index: 998; ">
	<div dojoType="dijit.Calendar" onValueSelected="dojo.byId('time_from').innerHTML=dojo.date.locale.format(arguments[0], {formatLength: 'medium', selector:'date'}); dojo.byId('calendar_from').style.display='none'; calendar_from_time=arguments[0]; reload_url(<?php echo $playerid; ?>,'act_graph');">
	</div>
</div>
<div id="calendar_to" class="claro" style="font-size: 8pt; display:none; position:absolute; top:50px; left:10px; z-index: 998; ">
	<div dojoType="dijit.Calendar" onValueSelected="dojo.byId('time_to').innerHTML=dojo.date.locale.format(arguments[0], {formatLength: 'medium', selector:'date'}); dojo.byId('calendar_to').style.display='none'; calendar_to_time=arguments[0]; reload_url(<?php echo $playerid; ?>,'act_graph');">
	</div>
</div>
<table border="0">
	<tr class="firstcolor"><td colspan="6"><?php echo str_replace("&1",$playername,DETAILEDINFO_ACTIVITY_DESCRIPTION); ?>
	<span id="time_from_text"><?php echo DETAILEDINFO_START; ?></span>
	<span id="time_from" style="display:none;"></span>
	<img src="../images/calendar.png" onclick="global_opening_calendar=true; ShowObjectAtMouse('calendar_from'); dojo.byId('time_from').style.display='inline'; dojo.byId('time_from_text').style.display='none';" />
	<?php echo DETAILEDINFO_TO; ?>
	<span id="time_to_text"><?php echo DETAILEDINFO_TODAY; ?></span>
	<span id="time_to" style="display:none;"></span>
	<img src="../images/calendar.png" onclick="global_opening_calendar=true; ShowObjectAtMouse('calendar_to'); dojo.byId('time_to').style.display='inline'; dojo.byId('time_to_text').style.display='none';" />
	<?php echo DETAILEDINFO_DATA_RESTRICTION; ?>
	</td></tr>
	<tr class="firstcolor">
		<td style="color: #FFB204;"><?php echo DETAILEDINFO_ALLYPAGE; ?></td>
		<td><input id="act_allypage" dojoType="dijit.form.CheckBox"
			name="allypage" checked onchange="reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td style="color: #FF0000;"><?php echo DETAILEDINFO_SCANS; ?></td>
		<td><input id="act_scans" dojoType="dijit.form.CheckBox"
			name="scans" checked onchange="reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td style="color: #C30027;"><?php echo DETAILEDINFO_MESSAGES; ?></td>
		<td><input id="act_messages" dojoType="dijit.form.CheckBox"
			name="messages" checked onchange="reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
	</tr>
	<tr class="firstcolor">
		<td style="color: #FF6B06;"><?php echo DETAILEDINFO_MANUAL; ?></td>
		<td><input id="act_manual" dojoType="dijit.form.CheckBox"
			name="manual" checked onchange="reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td style="color: #C3D564;"><?php echo DETAILEDINFO_GALAXYVIEWS; ?></td>
		<td><input id="act_galaxyview" dojoType="dijit.form.CheckBox"
			name="galaxyview" checked onchange="reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td style="color: #F1E804;"><?php echo DETAILEDINFO_COMBATS; ?></td>
		<td><input id="act_combat_reports" dojoType="dijit.form.CheckBox"
			name="combat_reports" checked onchange="reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
	</tr>
</table>
<table border="0" id="day_selection">
	<tr class="firstcolor">
	<?php
	echo '<td style="text-align:center;" id="monday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_MONDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="tuesday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_TUESDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="wednesday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_WEDNESDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="thursday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_THURSDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="friday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_FRIDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="saturday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_SATURDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="sunday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_SUNDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="workingday">'.
	mb_substr(DETAILEDINFO_WEEKDAY_MONDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')." - ".
	mb_substr(DETAILEDINFO_WEEKDAY_FRIDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";

	echo '<td style="text-align:center;" id="weekend">'.
	mb_substr(DETAILEDINFO_WEEKDAY_SATURDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')." - ".
	mb_substr(DETAILEDINFO_WEEKDAY_SUNDAY,0,DETAILEDINFO_WEEKDAY_SHORTLENGTH,'UTF-8')."</td>\n";
	?>
	</tr>
	<tr class="firstcolor">
		<td align="center"><input id="monday" dojoType="dijit.form.CheckBox"
			name="monday" checked onclick="handle_day_change('monday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="tuesday" dojoType="dijit.form.CheckBox"
			name="tuesday" checked onclick="handle_day_change('tuesday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="wednesday" dojoType="dijit.form.CheckBox"
			name="wednesday" checked onclick="handle_day_change('wednesday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="thursday" dojoType="dijit.form.CheckBox"
			name="thursday" checked onclick="handle_day_change('thursday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="friday" dojoType="dijit.form.CheckBox"
			name="friday" checked onclick="handle_day_change('friday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="saturday" dojoType="dijit.form.CheckBox"
			name="saturday" checked onclick="handle_day_change('saturday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="sunday" dojoType="dijit.form.CheckBox"
			name="sunday" checked onclick="handle_day_change('sunday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="workingday" dojoType="dijit.form.CheckBox"
			name="workingday" checked onclick="handle_day_change('workingday'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
		<td align="center"><input id="weekend" dojoType="dijit.form.CheckBox"
			name="weekend" checked onclick="handle_day_change('weekend'); reload_url(<?php echo $playerid; ?>,'act_graph')" /></td>
	</tr>
</table>
<div style="display:none">
<div dojoType="dijit.Tooltip" connectId="monday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_MONDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="tuesday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_TUESDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="wednesday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_WEDNESDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="thursday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_THURSDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="friday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_FRIDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="saturday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_SATURDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="sunday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_SUNDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="workingday" position="above">
<?php echo DETAILEDINFO_WEEKDAY_WORKINGDAY; ?>
</div>
<div dojoType="dijit.Tooltip" connectId="weekend" position="above">
<?php echo DETAILEDINFO_WEEKDAY_WEEKEND; ?>
</div>
</div>
<table border="0">
	<tr><td>

	<div id="act_graph">
<?php
$_GET['galaxy']   = 1;
$_GET['scans']    = 1;
$_GET['messages'] = 1;
$_GET['combats']  = 1;
$_GET['allypage'] = 1;
$_GET['manual']   = 1;

chdir("./ajax");
include "ajax_activity_graph.php";
?>
	</div>
	</td></tr>
</table>
<br>
<?php
if ($_SESSION['s_caninsert']) {
?>
<div class="failure"><?php echo DETAILEDINFO_OGAME_SERVERTIMES; ?></div>
<br>
<div class="tblhead" style="width:550px;" dojoType="dijit.TitlePane" title="<?php echo DETAILEDINFO_ENTER_MANUALLY; ?>" open="false">
<?php
/* removed until a good solution was found to determine correct time of Ogame (is no longer CET for all installations)
	<p align="center">
	<button dojoType="dijit.form.Button" type="button" onclick="set_player_active(<?php echo $playerid; ?>);"><?php echo DETAILEDINFO_PLAYER_CURRENTLY_ACTIVE; ?></button>
	</p>
*/
?>
	<div class="firstcolor">
	<?php echo DETAILEDINFO_PLAYER_SEEN_ON; ?>
	<input type="text" name="date" value="" dojoType="dijit.form.DateTextBox" trim="true" id="date" propercase="false" style="width:75px;">
	<select name="select_h" dojoType="dijit.form.Select" id="time_h" jsId="time_h" maxheight="400">
	<?php
	for ($i=0; $i<24; $i++) {
			$time_h = sprintf("%02d",$i);
			echo "<option value=\"$time_h\">$time_h</option>\n";
	}
	?>
	</select>:
	<select name="select_m" dojoType="dijit.form.Select" id="time_m" jsId="time_m" maxheight="400">
	<?php
	for ($j=0;$j<4;$j++) {
		$time_m = sprintf("%02d",$j*15);
		echo "<option value=\"$time_m\">$time_m</option>\n";
	}
	?>
	</select>
	<button dojoType="dijit.form.Button" type="button" onclick="set_player_activity(<?php echo $playerid; ?>);"><?php echo DETAILEDINFO_INSERT; ?></button>
	</div>

</div>
<?php
} // if ($_SESSION['s_caninsert']) {
?>
</div>