<?php

if (isset($_SESSION['lang'])) {
	switch ($_SESSION['lang']) {
	case "german":
		include_once "../languages/german.inc.php";
		break;
	case "english":
		include_once "../languages/english.inc.php";
		break;
	case "spanish":
		include_once "../languages/spanish.inc.php";
		break;
	case "dutch":
		include_once "../languages/dutch.inc.php";
		break;
	case "balkan":
		include_once "../languages/balkan.inc.php";
		break;
	case "french":
		include_once "../languages/french.inc.php";
		break;
	case "portugues":
		include_once "../languages/portugues.inc.php";
		break;
	case "polish":
		include_once "../languages/polish.inc.php";
		break;
	case "italian":
		include_once "../languages/italian.inc.php";
		break;
	case "turkish":
		include_once "../languages/turkish.inc.php";
		break;
	case "danish":
		include_once "../languages/danish.inc.php";
		break;
	case "brazilian":
		include_once "../languages/brazilian.inc.php";
		break;
	case "russian":
		include_once "../languages/russian.inc.php";
		break;
	case "swedish":
		include_once "../languages/swedish.inc.php";
		break;
	case "greek":
		include_once "../languages/greek.inc.php";
		break;
	case "romanian":
		include_once "../languages/romanian.inc.php";
		break;
	case "hungarian":
		include_once "../languages/hungarian.inc.php";
		break;
	case "czech":
		include_once "../languages/czech.inc.php";
		break;
	case "korean":
		include_once "../languages/korean.inc.php";
		break;
	case "norwegian":
		include_once "../languages/norwegian.inc.php";
		break;
	case "taiwan":
		include_once "../languages/taiwan.inc.php";
		break;
	case "japan":
		include_once "../languages/japanese.inc.php";
		break;
	case "chinese":
		include_once "../languages/chinese.inc.php";
		break;
	case "bulgarian":
		include_once "../languages/bulgarian.inc.php";
		break;
	case "lithuanian":
		include_once "../languages/lithuanian.inc.php";
		break;
	case "latvian":
		include_once "../languages/latvian.inc.php";
		break;
	case "finnish":
		include_once "../languages/finnish.inc.php";
		break;
	case "slovak":
		include_once "../languages/slovak.inc.php";
		break;
	case "croatian":
		include_once "../languages/croatian.inc.php";
		break;
	case "serbian":
		include_once "../languages/serbian.inc.php";
		break;
	case "slovenian":
		include_once "../languages/slovenian.inc.php";
		break;
	default:
		include_once "../languages/english.inc.php";
	}
} else {
	include_once "../languages/english.inc.php";
}

class ProbeLanguages {

	private $flipped_probe_array;
	private $flipped_top_array;
	public $report_when;

	function __construct() {
		switch ($_SESSION['lang']) {
		case "english":
			@include "../languages/english_probes.inc.php";
			break;
		case "german":
			@include "../languages/german_probes.inc.php";
			break;
		case "spanish":
			@include "../languages/spanish_probes.inc.php";
			break;
		case "dutch":
			@include "../languages/dutch_probes.inc.php";
			break;
		case "balkan":
			@include "../languages/balkan_probes.inc.php";
			break;
		case "french":
			@include "../languages/french_probes.inc.php";
			break;
		case "portugues":
			@include "../languages/portugues_probes.inc.php";
			break;
		case "polish":
			@include "../languages/polish_probes.inc.php";
			break;
		case "italian":
			@include "../languages/italian_probes.inc.php";
			break;
		case "turkish":
			@include "../languages/turkish_probes.inc.php";
			break;
		case "danish":
			@include "../languages/danish_probes.inc.php";
			break;
		case "brazilian":
			@include "../languages/brazilian_probes.inc.php";
			break;
		case "russian":
			@include "../languages/russian_probes.inc.php";
			break;
		case "swedish":
			@include "../languages/swedish_probes.inc.php";
			break;
		case "greek":
			@include "../languages/greek_probes.inc.php";
			break;
		case "romanian":
			@include "../languages/romanian_probes.inc.php";
			break;
		case "hungarian":
			@include "../languages/hungarian_probes.inc.php";
			break;
		case "czech":
			@include "../languages/czech_probes.inc.php";
			break;
		case "korean":
			@include "../languages/korean_probes.inc.php";
			break;
		case "norwegian":
			@include "../languages/norwegian_probes.inc.php";
			break;
		case "taiwan":
			@include "../languages/taiwan_probes.inc.php";
			break;
		case "japan":
			@include "../languages/japanese_probes.inc.php";
			break;
		case "chinese":
			@include "../languages/chinese_probes.inc.php";
			break;
		case "bulgarian":
			@include "../languages/bulgarian_probes.inc.php";
			break;
		case "lithuanian":
			@include "../languages/lithuanian_probes.inc.php";
			break;
		case "latvian":
			@include "../languages/latvian_probes.inc.php";
			break;
		case "finnish":
			@include "../languages/finnish_probes.inc.php";
			break;
		case "slovak":
			@include "../languages/slovak_probes.inc.php";
			break;
		case "croatian":
			@include "../languages/croatian_probes.inc.php";
			break;
		case "serbian":
			@include "../languages/serbian_probes.inc.php";
			break;
		case "slovenian":
			@include "../languages/slovenian_probes.inc.php";
			break;
		default:
			@include "../languages/english_probes.inc.php";
			break;
		}

		if ($_SESSION['lang'] == "english") {
			// no need to flip
			$this->flipped_probe_array = $probe_array;
			$this->flipped_top_array = $top_array;
		} else {
			$this->flipped_probe_array = array_flip($probe_array);
			$this->flipped_top_array = array_flip($top_array);
		}
		$this->report_when = $report_when;
	}

	public function get_flipped_probe_array() {
		return $this->flipped_probe_array;
	}

	public function get_flipped_top_array() {
		return $this->flipped_top_array;
	}
}

?>